// Copyright © 2020 The Knative Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package sources

import (
	"testing"

	"gotest.tools/v3/assert"

	sourcesv1 "knative.dev/eventing/pkg/apis/sources/v1"
	sourcesv1beta2 "knative.dev/eventing/pkg/apis/sources/v1beta2"
)

func TestBuiltInSourcesGVks(t *testing.T) {
	gvks := BuiltInSourcesGVKs()
	for _, each := range gvks {
		if each.Kind != "PingSource" {
			assert.DeepEqual(t, each.GroupVersion(), sourcesv1.SchemeGroupVersion)
		} else {
			assert.DeepEqual(t, each.GroupVersion(), sourcesv1beta2.SchemeGroupVersion)
		}
	}
	assert.Equal(t, len(gvks), 4)
}
